#define dcolor 8
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <graphics.h>
#include <Conio.h>
#include <process.h>

int GetBit(unsigned char c,int n);
int handle;


int OpenHz(char* HzPath)
{
   return handle=open(HzPath,O_RDONLY|O_BINARY);
}

int Wrt16Hz(int x, int y,int z,int color,char *p)
{
 unsigned int i,c1,c2,f=0;               /*x,y:write at (x,y);*/
 int rec,i1,i2,i3;                       /*z:space between;   */
 long l;                                 /*color:txt color    */
 char by[32];                            /*p:HZ str           */

 if( handle<0 ) return -1;

 while((i=*p++)!=0){
   if(i>0xa1)
      if(f==0){
	   c1=(i-0xa1)&0x07f;
	   f=1;
	   }
	  else{
	   c2=(i-0xa1)&0x07f;
	   f=0;
	   rec=c1*94+c2;
	   l=rec*32L;
	   lseek(handle,l,SEEK_SET);
	   read(handle,by,32);
	   for(i1=0;i1<16;i1++)
	for(i2=0;i2<2;i2++)
	 for(i3=0;i3<8;i3++)
	  if(GetBit(by[i1*2+i2],7-i3))
	   putpixel(x+i2*8+i3,y+i1,color);
	   x=x+z+16;
	  }
  }
 return(x);
}


int Wrt24Hz(int x,int y,int z,int color,int m,int n,char *p)
{
 unsigned int i,c1,c2,f=0;         /*z:space between two HZ       */
 int i1,i2,i3,i4,i5,rec;           /*x,y:position(x,y) to locate  */
 long l;                           /*color:from 0 to 15           */
 char by[72];                      /*m:x scale                    */
				   /*n:y scale                    */
 if( handle<0 ) return -1;

 while((i=*p++)!=0){               /*p:HZ str                     */
   if(i>0xa1)
      if(f==0){
	c1=(i-0xa1)&0x7f;
	f=1;
	}
      else{
	c2=(i-0xa1)&0x7f;
	f=0;
	rec=(c1-15)*94+c2;
	l=rec*72L;
	lseek(handle,l,SEEK_SET);
	read(handle,by,72);
	for(i1=0;i1<24*m;i1=i1+m)
	 for(i4=0;i4<m;i4++)
	  for(i2=0;i2<=2;i2++)
	   for(i3=0;i3<8;i3++)
		if(GetBit(by[i1/m*3+i2],7-i3))
		 for(i5=0;i5<n;i5++)
		  putpixel(x+i1+i4,y+i2*8*n+i3*n+i5,color);
	x=x+24*m+z;
	}
   }
 return(x);
}

int GetBit(unsigned char c,int n)
{
 if( handle<0 ) return 0;

 return((c>>n)&1);
}

void CloseHz(void){
  close( handle );
}
/******************** Program *****************************/
main ()
{
int driver=DETECT,mode,g_error;
if(registerbgidriver(EGAVGA_driver)<0)exit(1);
initgraph(&driver,&mode," ");
g_error=graphresult();
if(g_error<0)
{printf("initgaph error:%s\n",grapherrormsg(g_error));
exit(1);}
setbkcolor(8);
WrtHz24(100,100,12,14,11,2,"ɷ");
getch();
closegraph();
}